/**
 * @file HighlightAlgorithmException.hpp
 * HighlightAlgorithmException.hpp excpetion class. Describe common exceptions for Highlight Algorithms executing.
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef HIGHLIGHT_ALGORITHM_EXCEPTION_HPP
#define HIGHLIGHT_ALGORITHM_EXCEPTION_HPP

#include "ExceptionBase.hpp"

namespace HCE
{
  namespace exception
  {
    class HighlightAlgorithmException : public ExceptionBase
    {
      public:
        HighlightAlgorithmException(const std::string &what):ExceptionBase(what) {}
        virtual ~HighlightAlgorithmException() throw(){}
    };
  }
}

#endif