/**
 * @file HighlightComponent.hpp
 * HighlightComponent class - Represent main higlight processing in the HCE::Component architectute
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef HIGLIGHT_COMPONENT_HPP
#define HIGLIGHT_COMPONENT_HPP

#include <Poco/SharedPtr.h>

#include "HCEConstants.hpp"
#include "ComponentBase.hpp"
#include "ContentsStorageBase.hpp"
#include "DataBase.hpp"
#include "HighlightStringGenerator.hpp"

namespace HCE
{
  namespace component
  {
    class HighlightComponent : public ComponentBase
    {
      private:
        HighlightStringGenerator highlightStringGenerator;
      public:
        HighlightComponent():ComponentBase(HCE::CT_HIGHLIGHT) {}
        HighlightStringGenerator &getHighlightStringGeneratorReference();
        virtual Poco::SharedPtr<DataBase> process(Poco::SharedPtr<DataBase> inData);
        virtual ~HighlightComponent() {}
    };
  }
}

#endif