/**
 * @file HighlightJsonException.hpp
 * HighlightJsonException excpetion class. Describe common exceptions for HighlightJson's operations.
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef HIGHLIGHT_JSON_EXCEPTION_HPP
#define HIGHLIGHT_JSON_EXCEPTION_HPP

#include "ExceptionBase.hpp"

namespace HCE
{
  namespace exception
  {
    class HighlightJsonException : public ExceptionBase
    {
      public:
        HighlightJsonException(const std::string &what):ExceptionBase(what) {}
        virtual ~HighlightJsonException() throw(){}
    };
  }
}

#endif