/**
 * @file HighlightStringStickerBase.hpp
 * HighlightStringStickerBase class gives method for stick together base content and  
 * highlight markes.
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */
#ifndef HIGHLIGHT_STRING_STICKER_BASE_HPP
#define HIGHLIGHT_STRING_STICKER_BASE_HPP

#include <string>

#include "WordPos.hpp"

class HighlightStringStickerBase
{
  public:
    HighlightStringStickerBase() {}
    virtual std::string fillOutPutStr(std::vector<WordPos> &wordOffsets, const std::string &incomeContent) = 0;
    virtual void reinitialize(Poco::SharedPtr<InDataStruct> inDataStructPtr) = 0;
    virtual void setHighlightedCounter(unsigned int _highlightedCounter) = 0;
    virtual unsigned int getHighlightedCounter() = 0;
    ~HighlightStringStickerBase() {}
};

#endif