/**
 * @file HighlightStringStickerSimple.hpp
 * HighlightStringStickerSimple class implements simple method for stick together base content and  
 * highlight markes.
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */
#ifndef HIGHLIGHT_STRING_STICKER_SIMPLE_HPP
#define HIGHLIGHT_STRING_STICKER_SIMPLE_HPP

#include "InDataStruct.hpp"
#include "HighlightStringStickerBase.hpp"

class HighlightStringStickerSimple : public HighlightStringStickerBase
{
  protected:
    std::string hlBegin;
    std::string hlEnd;
    unsigned int maxNumber;
    unsigned int highlightedCounter;
  public:
    HighlightStringStickerSimple();
    virtual std::string fillOutPutStr(std::vector<WordPos> &wordOffsets, const std::string &incomeContent);
    virtual void reinitialize(Poco::SharedPtr<InDataStruct> inDataStructPtr);
    inline void setHlBegin(const std::string &_hlBegin);
    inline void setHlEnd(const std::string &_hlEnd);
    inline void setMaxNumber(unsigned int _maxNumber);
    virtual void setHighlightedCounter(unsigned int _highlightedCounter);
    virtual unsigned int getHighlightedCounter();
    ~HighlightStringStickerSimple();
};

void HighlightStringStickerSimple::setHlBegin(const std::string &_hlBegin)
{
  hlBegin = _hlBegin;
}

void HighlightStringStickerSimple::setHlEnd(const std::string &_hlEnd)
{
  hlEnd = _hlEnd;
}

void HighlightStringStickerSimple::setMaxNumber(unsigned int _maxNumber)
{
  maxNumber = _maxNumber;
}

#endif