/**
 * @file HighlightingAlgorithmInitialize.cpp
 * ASM::HighlightingAlgorithmsInit function implementation.
 * 
 * 
 * @author Andrey Lapshov <developers.asm.cluster@gmail.com>
 * @link http://asm-search-engine.com/cluster/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://asm-search-engine.com/cluster/license/
 * @package ASM Cluster node API
 * @since 0.1
 */

#include "HighlightingAlgorithmInitialize.hpp"

namespace HCE
{
  void HighlightingAlgorithmsInit(HighlightStringGenerator &highlightStringGenerator)
  {
    highlightStringGenerator.addHighlightingAlgorithm(Poco::SharedPtr<HighlightingAlgorithmBase>(new HighlightingAlgorithmRefine(0, 0)));
    highlightStringGenerator.addHighlightingAlgorithm(Poco::SharedPtr<HighlightingAlgorithmBase>(new HighlightingAlgorithmSimple()));
    highlightStringGenerator.addHighlightingAlgorithm(Poco::SharedPtr<HighlightingAlgorithmBase>(new HighlightingAlgorithmRegexpr()));    
  }
};