/**
 * @file HighlightingAlgorithmRegexpr.hpp
 *
 * Class HighlightingAlgorithmRegexpr. It contains implementation of HighlightingAlgorithmRegexpr algorithm
 * 
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef HIGHLIGHTING_ALGORITHM_REGEXPR_HPP
#define HIGHLIGHTING_ALGORITHM_REGEXPR_HPP

#include <map>
#include <Poco/SharedPtr.h>
#include <string>
#include <vector>

#include "InDataStruct.hpp"
#include "HighlightingAlgorithmBase.hpp"
#include "WordPos.hpp"

class HighlightingAlgorithmRegexpr : public HighlightingAlgorithmBase
{
  private:
    std::string name;
  public:
    HighlightingAlgorithmRegexpr():name("(A-Poco::Regexpr)") {}
    virtual void process(const std::vector<std::pair<SearchType, std::string> > &searchStrings, const Poco::SharedPtr<std::string> contentPtr,
                 ContentsStorageBase::WordPosPtrType wordMapPtr, std::map<unsigned int, WordPos> &wordOffsetMap);
    virtual std::string getName() {return name;}
    virtual ~HighlightingAlgorithmRegexpr() {}
};

#endif