/**
 * @file HighlightingAlgorithmSimple.hpp
 *
 * Class HighlightingAlgorithmSimple. It contains Simple Highlighting Algoritm implementation.
 * 
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef HIGHLIGHTING_ALGORITHM_SIMPLE_HPP
#define HIGHLIGHTING_ALGORITHM_SIMPLE_HPP

#include "HighlightingAlgorithmBase.hpp"

class HighlightingAlgorithmSimple : public HighlightingAlgorithmBase
{
  private:
    unsigned int maxNumber;
    std::string name;
  public:
    HighlightingAlgorithmSimple():maxNumber(0xFFFFFFFF), name("(A-Simple substring)") {}
    virtual void process(const std::vector<std::pair<SearchType, std::string> > &searchStrings, const Poco::SharedPtr<std::string> contentPtr,
                 ContentsStorageBase::WordPosPtrType wordMapPtr, std::map<unsigned int, WordPos> &wordOffsetMap);
    inline void setMaxNumber(unsigned int _maxNumber) {maxNumber = _maxNumber;}
    virtual std::string getName() {return name;}
    virtual ~HighlightingAlgorithmSimple() {}
};

#endif