#include "Algorithms.hpp"
#include "SearchStringParser.hpp"
#include "SearchStringParseException.hpp"

using namespace HCE::exception;

void SearchStringParser::setSearchString(std::vector<std::pair<SearchType, std::string> > &sVec,  SearchType searchType, std::string &searchString)
{
  if(searchString.length() > 0)
  {
    sVec.push_back(std::pair<SearchType, std::string>(searchType, searchString));
    searchString = "";
  }  
}

std::vector<std::pair<SearchType, std::string> > SearchStringParser::parseSearchString(const std::string &searchString)
{
  std::vector<std::pair<SearchType, std::string> > ret;
  SearchType localSearchType = SearchType::ST_SINGLE;
  std::string localSearchStr;
  for(unsigned int i = 0; i < searchString.length(); i++)
  {
    if(searchString[i] == '"')
    {
      if(localSearchType == SearchType::ST_SINGLE)
      {
        setSearchString(ret, localSearchType, localSearchStr);
        localSearchType = SearchType::ST_STRICKT;
      }
      else if(localSearchType == SearchType::ST_STRICKT)
      {
        setSearchString(ret, localSearchType, localSearchStr);
        localSearchType = SearchType::ST_SINGLE;
      }
      else if(localSearchType == SearchType::ST_NO_STRICKT)
      {
        throw SearchStringParseException("BAD SEARCH SEQUENCE");
      }
    }
    else if(searchString[i] == '\'')
    {
      if(localSearchType == SearchType::ST_SINGLE)
      {
        setSearchString(ret, localSearchType, localSearchStr);
        localSearchType = SearchType::ST_NO_STRICKT;
      }
      else if(localSearchType == SearchType::ST_STRICKT)
      {
        throw SearchStringParseException("BAD SEARCH SEQUENCE");
      }
      else if(localSearchType == SearchType::ST_NO_STRICKT)
      {
        setSearchString(ret, localSearchType, localSearchStr);
        localSearchType = SearchType::ST_SINGLE;        
      }
    }
    else if(searchString[i] == ' ')
    {
      if(localSearchType == SearchType::ST_SINGLE)
      {
	setSearchString(ret, localSearchType, localSearchStr);
      }
      else
      {
	localSearchStr += searchString[i];
      }
    }
    else
    {
      localSearchStr += searchString[i];
    }
  }
  setSearchString(ret, localSearchType, localSearchStr);
  return ret;  
}

std::vector<std::vector<std::pair<SearchType, std::string> > > SearchStringParser::parse(const std::string &searchString, const std::string &algorithmSeparator)
{
  std::vector<std::vector<std::pair<SearchType, std::string> > > ret;
  if(!searchString.empty())
  {
    std::vector<std::string> algorithmStrings = HCE::algorithms::stringSplitter(searchString, algorithmSeparator, true);
    for(unsigned int i = 0; i < algorithmStrings.size(); i++)
    {
      if(algorithmStrings[i].empty())
      {
	ret.push_back(std::vector<std::pair<SearchType, std::string> >());
	continue;
      }
      try
      {  
	ret.push_back(parseSearchString(algorithmStrings[i]));
      }
      catch(SearchStringParseException &excp)
      {
	ret.push_back(std::vector<std::pair<SearchType, std::string> >());
      }
    }
  }
  return ret;
}