/**
 * @file SearchStringParser.hpp
 *
 * class SearchStringParser parses and splits incoming searchString
 * 
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef SEARCH_STRING_PARSER_HPP
#define SEARCH_STRING_PARSER_HPP

#include "InDataStruct.hpp"

#include <string>
#include <vector>

class SearchStringParser
{
  private:
    static void setSearchString(std::vector<std::pair<SearchType, std::string> > &sVec,  SearchType searchType, std::string &searchString);
    static std::vector<std::pair<SearchType, std::string> > parseSearchString(const std::string &searchString);
  public:
    SearchStringParser() {}
    static std::vector<std::vector<std::pair<SearchType, std::string> > > parse(const std::string &searchString, const std::string &algorithmSeparator);
    ~SearchStringParser() {}
};

#endif