/**
 * @file SerializeCachData.hpp
 * SerializeCachData class. It class content fields, that will be serialized and contents cache info
 *
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API	
 * @since 0.1
 */

#ifndef SERIALIZE_CACHE_DATA_HPP
#define SERIALIZE_CACHE_DATA_HPP

#include <msgpack.hpp>

#include "ContentsStorageBase.hpp"

struct SerializeCacheData
{
  SerializeCacheData():resCrc(0) {}
  SerializeCacheData(std::vector<std::map<unsigned long long, std::vector<WordPos> > > _data, unsigned long long _resCrc):data(_data), resCrc(_resCrc){}
  ~SerializeCacheData() {}
  std::vector<std::map<unsigned long long, std::vector<WordPos> > > data;
  unsigned long long resCrc;
  MSGPACK_DEFINE(data, resCrc);
};

#endif