/**
 * @file WordPos.hpp
 *
 * structure WordPos. It struct contains word data for word's chains search
 * 
 * @author Andrey Lapshov <developers.hce@gmail.com>
 * @link http://hierarchical-cluster-engine.com/
 * @copyright Copyright &copy; 2013 IOIX Ukraine
 * @license http://hierarchical-cluster-engine.com/license/
 * @package HCE project node API
 * @since 0.1
 */

#ifndef WORDS_POS_HPP
#define WORDS_POS_HPP

#include <msgpack.hpp>

struct WordPos
{
  WordPos():beginOffset(0), endOffset(0), position(0), segmentId(0) {}
  WordPos(unsigned int _beginOffset, unsigned int _endOffset, unsigned int _position, unsigned int _segmentId): 
          beginOffset(_beginOffset), endOffset(_endOffset), position(_position), segmentId(_segmentId) {}
  unsigned int beginOffset;
  unsigned int endOffset;
  unsigned int position;
  unsigned int segmentId;
  MSGPACK_DEFINE(beginOffset, endOffset, position, segmentId);
};

#endif