#include "TaskWaitObjectWrapper.hpp"
#include "TaskComponentException.hpp"

namespace HCE
{
// cppcheck-suppress unusedFunction  
  void TaskWaitObjectWrapper::runTask()
  {
    if(!_task.isNull())
    {
      if(!_componentPtr.isNull())
      {
        try
        {
          _task->setOutData(_componentPtr->process(_task->getInData()), HCECTE_DEFAULT, NULL);
        }
        catch(ComponentExceptionBase &exp)
        {
          _task->setOutData(NULL, HCECTE_COMPONENT_EXP, Poco::SharedPtr<ComponentExceptionBase>(new ComponentExceptionBase(exp)));
        }
        catch(ExceptionBase &exp)
        {
          _task->setOutData(NULL, HCECTE_EXP_BASE, NULL);
        }
      }
      else
      {
        _task->setOutData(NULL, HCECTE_EXP1, NULL);
      }
    }
    if(!_componentPtr.isNull())
    {
      _componentPtr->setIsBusy(false);
    }
  }
}