#ifndef TASK_WAIT_OBJECT_WRAPPER_HPP
#define TASK_WAIT_OBJECT_WRAPPER_HPP

#include <Poco/SharedPtr.h>
#include <Poco/Mutex.h>
#include <Poco/Task.h>

#include "HCEConstants.hpp"
#include "ComponentBase.hpp"
#include "DataBase.hpp"
#include "TaskComponentException.hpp"
#include "TaskWaitObject.hpp"

namespace HCE
{
  using namespace HCE::component;
  class TaskWaitObjectWrapper : public Poco::Task
  {
    protected:
      Poco::SharedPtr<TaskWaitObject> _task;
      Poco::SharedPtr<ComponentBase> _componentPtr;
      Poco::FastMutex &componentMutex;
    public:
      TaskWaitObjectWrapper(Poco::SharedPtr<TaskWaitObject> task, Poco::SharedPtr<ComponentBase> componentPtr, Poco::FastMutex &mutex)
                           :Poco::Task(componentNames[static_cast<int>(task->getType())]), componentMutex(mutex)
      {
        _task = task;
        _componentPtr = componentPtr;
      }
      virtual void runTask();
      ~TaskWaitObjectWrapper(){}
  };
}

#endif